VERSION 5.00
Begin VB.Form frmMain 
   BorderStyle     =   1  'Fest Einfach
   Caption         =   "GetHostAsyn"
   ClientHeight    =   4575
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   6810
   BeginProperty Font 
      Name            =   "Tahoma"
      Size            =   8.25
      Charset         =   0
      Weight          =   400
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   Icon            =   "frmMain.frx":0000
   LinkTopic       =   "Form1"
   LockControls    =   -1  'True
   MaxButton       =   0   'False
   ScaleHeight     =   305
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   454
   StartUpPosition =   2  'Bildschirmmitte
   Begin VB.CommandButton cmdCopy 
      Caption         =   "&Copy Info"
      Enabled         =   0   'False
      Height          =   360
      Left            =   5625
      TabIndex        =   13
      Top             =   480
      Width           =   1125
   End
   Begin VB.ComboBox cboHost 
      Height          =   315
      ItemData        =   "frmMain.frx":000C
      Left            =   1950
      List            =   "frmMain.frx":001F
      TabIndex        =   1
      Top             =   120
      Width           =   3600
   End
   Begin VB.TextBox txtHostname 
      BackColor       =   &H8000000F&
      Height          =   300
      Left            =   1950
      Locked          =   -1  'True
      TabIndex        =   4
      Top             =   510
      Width           =   3600
   End
   Begin VB.TextBox txtAddrLength 
      BackColor       =   &H8000000F&
      Height          =   300
      Left            =   1950
      Locked          =   -1  'True
      TabIndex        =   10
      Top             =   2715
      Width           =   3600
   End
   Begin VB.TextBox txtAddrType 
      BackColor       =   &H8000000F&
      Height          =   300
      Left            =   1950
      Locked          =   -1  'True
      TabIndex        =   8
      Top             =   2355
      Width           =   3600
   End
   Begin VB.ListBox lstAddrList 
      BackColor       =   &H8000000F&
      Height          =   1425
      Left            =   1950
      TabIndex        =   12
      Top             =   3075
      Width           =   3600
   End
   Begin VB.ListBox lstAliases 
      BackColor       =   &H8000000F&
      Height          =   1425
      Left            =   1950
      TabIndex        =   6
      Top             =   870
      Width           =   3600
   End
   Begin VB.CommandButton cmdQuery 
      Caption         =   "&Query"
      Default         =   -1  'True
      Height          =   360
      Left            =   5625
      TabIndex        =   2
      Top             =   90
      Width           =   1125
   End
   Begin VB.Label lblHostname 
      Caption         =   "HOSTENT.h_name:"
      Height          =   225
      Left            =   120
      TabIndex        =   3
      Top             =   555
      Width           =   1740
   End
   Begin VB.Label lblAliases 
      Caption         =   "HOSTENT.h_aliases:"
      Height          =   225
      Left            =   120
      TabIndex        =   5
      Top             =   1470
      Width           =   1740
   End
   Begin VB.Label lblAddrType 
      Caption         =   "HOSTENT.h_addrtype:"
      Height          =   225
      Left            =   120
      TabIndex        =   7
      Top             =   2400
      Width           =   1740
   End
   Begin VB.Label lblAddrLength 
      Caption         =   "HOSTENT.h_length:"
      Height          =   225
      Left            =   120
      TabIndex        =   9
      Top             =   2760
      Width           =   1740
   End
   Begin VB.Label lblAddrList 
      Caption         =   "HOSTENT.h_addr_list:"
      Height          =   225
      Left            =   120
      TabIndex        =   11
      Top             =   3675
      Width           =   1740
   End
   Begin VB.Label lblHost 
      Caption         =   "Host:"
      Height          =   225
      Left            =   120
      TabIndex        =   0
      Top             =   195
      Width           =   1740
   End
End
Attribute VB_Name = "frmMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
'----------------------------------------------------------------------------------------------------
'====================================================================================================
'= Variables
'====================================================================================================
'-------------------------------------------------------------------|--------------------------------
Private WithEvents objHost                  As clsHost              '
Attribute objHost.VB_VarHelpID = -1
'-------------------------------------------------------------------|--------------------------------
'----------------------------------------------------------------------------------------------------



'####################################################################################################
'#####[ Form ]#######################################################################################
'####################################################################################################
Private Sub Form_Load()
    cboHost.ListIndex = 0
    '
    Set objHost = New clsHost
End Sub

Private Sub Form_Unload(Cancel As Integer)
    Set objHost = Nothing
    '
    Set frmMain = Nothing
End Sub


'####################################################################################################
'#####[ Buttons ]####################################################################################
'####################################################################################################
Private Sub cmdQuery_Click()
    cmdQuery.Enabled = False
    cmdCopy.Enabled = False
    '
    frmMain.Caption = "GetHostAsyn (Host Informationen abfragen)"
    '
    cboHost.SetFocus
    txtHostname.Text = vbNullString
    lstAliases.Clear
    txtAddrType.Text = vbNullString
    txtAddrLength.Text = vbNullString
    lstAddrList.Clear
    '
    objHost.GetHostInfo cboHost.Text
End Sub

Private Sub cmdCopy_Click()
    Dim strClipboard  As String
    Dim strAliases()  As String
    Dim strAddrList() As String
    Dim i             As Long
    '
    If lstAliases.ListCount > 0 Then
        ReDim strAliases(1 To lstAliases.ListCount)
        For i = LBound(strAliases()) To UBound(strAliases())
            strAliases(i) = lstAliases.List(i - 1)
        Next i
    Else
        ReDim strAliases(0 To 0)
    End If
    '
    If lstAddrList.ListCount > 0 Then
        ReDim strAddrList(1 To lstAddrList.ListCount)
        For i = LBound(strAddrList()) To UBound(strAddrList())
            strAddrList(i) = lstAddrList.List(i - 1)
        Next i
    Else
        ReDim strAddrList(0 To 0)
    End If
    '
    strClipboard = "HOSTENT.h_name      = " & txtHostname.Text & vbCrLf & _
                   "HOSTENT.h_aliases   = " & Join(strAliases(), "; ") & vbCrLf & _
                   "HOSTENT.h_addrtype  = " & txtAddrType.Text & vbCrLf & _
                   "HOSTENT.h_length    = " & txtAddrLength.Text & vbCrLf & _
                   "HOSTENT.h_addr_list = " & Join(strAddrList(), "; ") & vbCrLf
    '
    Clipboard.SetText strClipboard, vbCFText
End Sub

'####################################################################################################
'#####[ Events ]#####################################################################################
'####################################################################################################
Private Sub objHost_HostResolved(ByVal Hostname As String, Aliases() As String, ByVal AddrType As String, ByVal AddrLength As Long, AddrList() As String)
    Dim i As Long
    '
    txtHostname.Text = Hostname
    '
    For i = 1 To UBound(Aliases())
        lstAliases.AddItem Aliases(i)
    Next i
    '
    txtAddrType.Text = AddrType
    '
    txtAddrLength.Text = CStr(AddrLength)
    '
    For i = 1 To UBound(AddrList())
        lstAddrList.AddItem AddrList(i)
    Next i
    '
    frmMain.Caption = "GetHostAsyn (Fertig)"
    '
    cmdQuery.Enabled = True
    cmdCopy.Enabled = True
End Sub

Private Sub objHost_Error(ByVal Number As Integer, Description As String, ByVal Source As String)
    txtHostname.Text = vbNullString
    lstAliases.Clear
    txtAddrType.Text = vbNullString
    txtAddrLength.Text = vbNullString
    lstAddrList.Clear
    '
    frmMain.Caption = "GetHostAsyn (Fehler)"
    '
    MsgBox "Error " & CStr(Number) & ": " & Description, _
           vbOKOnly Or vbCritical
    '
    cmdQuery.Enabled = True
End Sub
